| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Static Public Member Functions | Protected Attributes | Private Attributes | List of all members
Gaudi::Histogram3D Class Reference

AIDA implementation for 3 D histograms using ROOT THD2. More...

`#include <GaudiCommonSvc/H3D.h>`

Inheritance diagram for Gaudi::Histogram3D:
[legend]
Collaboration diagram for Gaudi::Histogram3D:
[legend]

## Public Member Functions
| Histogram3D ()
| Standard Constructor. More...
| Histogram3D (TH3D *rep)
| Standard Constructor. More...
bool | fill (double x, double y, double z, double weight) override
| Fill bin content. More...
virtual bool | setBinContents (int i, int j, int k, int entries, double height, double error, double centreX, double centreY, double centreZ)
| Fast filling method for a given bin. It can be also the over/underflow bin. More...
virtual bool | setRms (double rmsX, double rmsY, double rmsZ)
| Sets the rms of the histogram. More...
bool | reset () override
void * | cast (const std::string &className) const override
| Introspection method. More...
void | copyFromAida (const AIDA::IHistogram3D &h)
| Create new histogram from any AIDA based histogram. More...
const CLID & | clID () const override
| Retrieve reference to class defininition identifier. More...
Public Member Functions inherited from DataObject
| DataObject ()
| Standard Constructor. More...
| DataObject (const DataObject &rhs)
| Copy Constructor. More...
DataObject & | operator= (const DataObject &rhs)
| Assignment Operator. More...
| DataObject (DataObject &&rhs)
| Move Constructor. More...
DataObject & | operator= (DataObject &&rhs)
| Move Assignment Operator. More...
virtual | ~DataObject ()
| Standard Destructor. More...
virtual unsigned long | addRef ()
| Add reference to object. More...
virtual unsigned long | release ()
| release reference to object More...
const std::string & | name () const
| Retreive DataObject name. It is the name when registered in the store. More...
virtual StatusCode | update ()
| Provide empty placeholder for internal object reconfiguration callback. More...
void | setRegistry (IRegistry *pRegistry)
| Set pointer to Registry. More...
IRegistry * | registry () const
| Get pointer to Registry. More...
LinkManager * | linkMgr () const
| Retrieve Link manager. More...
unsigned char | version () const
| Retrieve version number of this object representation. More...
void | setVersion (unsigned char vsn)
| Set version number of this object representation. More...
unsigned long | refCount () const
| Return the refcount. More...
virtual std::ostream & | fillStream (std::ostream &s) const
| Fill the output stream (ASCII) More...
Public Member Functions inherited from Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >
| Generic3D ()=default
| Default constructor. More...
TObject * | representation () const override
| ROOT object implementation. More...
void | adoptRepresentation (TObject *rep) override
| Adopt ROOT histogram representation. More...
int | dimension () const override
| Get the Histogram's dimension. More...
std::string | title () const override
| Get the title of the object. More...
bool | setTitle (const std::string &title) override
| Set the title of the object. More...
std::string | name () const
| object name More...
bool | setName (const std::string &newName)
| Sets the name of the object. More...
AIDA::IAnnotation & | annotation () override
| Access annotation object. More...
const AIDA::IAnnotation & | annotation () const override
| Access annotation object (cons) More...
int | entries () const override
| Get the number or all the entries. More...
int | allEntries () const override
| Get the number or all the entries, both in range and underflow/overflow bins of the IProfile. More...
double | sumBinHeights () const override
| Get the sum of in range bin heights in the IProfile. More...
double | sumAllBinHeights () const override
| Get the sum of all the bins heights (including underflow and overflow bin). More...
double | sumExtraBinHeights () const override
| Get the sum of the underflow and overflow bin height. More...
double | minBinHeight () const override
| Get the minimum height of the in-range bins. More...
double | maxBinHeight () const override
| Get the maximum height of the in-range bins. More...
int | rIndexX (int index) const
int | rIndexY (int index) const
int | rIndexZ (int index) const
double | binMeanX (int indexX, int, int) const override
| The weighted mean along the x axis of a given bin. More...
double | binMeanY (int, int indexY, int) const override
| The weighted mean along the y axis of a given bin. More...
double | binMeanZ (int, int, int indexZ) const override
| The weighted mean along the z axis of a given bin. More...
int | binEntries (int indexX, int indexY, int indexZ) const override
| Number of entries in the corresponding bin (ie the number of times fill was calle d for this bin). More...
int | binEntriesX (int index) const override
| Sum of all the entries of the bins along a given x bin. More...
int | binEntriesY (int index) const override
| Sum of all the entries of the bins along a given y bin. More...
int | binEntriesZ (int index) const override
| Sum of all the entries of the bins along a given z bin. More...
double | binHeight (int indexX, int indexY, int indexZ) const
| Total height of the corresponding bin (ie the sum of the weights in this bin). More...
double | binHeightX (int index) const override
| Sum of all the heights of the bins along a given x bin. More...
double | binHeightY (int index) const override
| Sum of all the heights of the bins along a given y bin. More...
double | binHeightZ (int index) const override
| Sum of all the heights of the bins along a given z bin. More...
double | binError (int indexX, int indexY, int indexZ) const override
| The error of a given bin. More...
double | meanX () const override
| The mean of the IHistogram3D along the x axis. More...
double | meanY () const override
| The mean of the IHistogram3D along the y axis. More...
double | meanZ () const override
| The mean of the IHistogram3D along the z axis. More...
double | rmsX () const override
| The RMS of the IHistogram3D along the x axis. More...
double | rmsY () const override
| The RMS of the IHistogram3D along the y axis. More...
double | rmsZ () const override
| The RMS of the IHistogram3D along the z axis. More...
const AIDA::IAxis & | xAxis () const override
| Get the x axis of the IHistogram3D. More...
const AIDA::IAxis & | yAxis () const override
| Get the y axis of the IHistogram3D. More...
const AIDA::IAxis & | zAxis () const override
| Get the z axis of the IHistogram3D. More...
int | coordToIndexX (double coord) const override
| Get the bin number corresponding to a given coordinate along the x axis. More...
int | coordToIndexY (double coord) const override
| Get the bin number corresponding to a given coordinate along the y axis. More...
int | coordToIndexZ (double coord) const override
| Get the bin number corresponding to a given coordinate along the z axis. More...
double | equivalentBinEntries () const override
| Number of equivalent entries, i.e. `SUM[ weight ] ^ 2 / SUM[ weight^2 ]` More...
bool | scale (double scaleFactor) override
| Scale the weights and the errors of all the IHistogram's bins (in-range and out-of-range ones) by a given scale factor. More...
bool | add (const INTERFACE &hist) override
| Add to this Histogram3D the contents of another IHistogram3D. More...
int | extraEntries () const override
std::ostream & | print (std::ostream &s) const override
| Print (ASCII) the histogram into the output stream. More...
std::ostream & | write (std::ostream &s) const override
| Write (ASCII) the histogram table into the output stream. More...
int | write (const char *file_name) const override
| Write (ASCII) the histogram table into a file. More...
template<>
void | adoptRepresentation (TObject *rep)
| Adopt ROOT histogram representation. More...
Public Member Functions inherited from Gaudi::HistogramBase
virtual | ~HistogramBase ()=default

## Static Public Member Functions
static const CLID & | classID ()
Static Public Member Functions inherited from DataObject
static const CLID & | classID ()
| Retrieve reference to class definition structure (static access) More...

## Protected Attributes
double | m_sumwx = 0
double | m_sumwy = 0
double | m_sumwz = 0
Protected Attributes inherited from Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >
Gaudi::Axis | m_xAxis
Gaudi::Axis | m_yAxis
Gaudi::Axis | m_zAxis
AIDA::Annotation | m_annotation
| Object annotations. More...
std::unique_ptr< IMPLEMENTATION > | m_rep
| Reference to underlying implementation. More...
std::string | m_classType
int | m_sumEntries = 0

## Private Attributes
std::mutex | m_fillSerialization

## Additional Inherited Members
Public Types inherited from Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >
typedef Generic3D< INTERFACE, IMPLEMENTATION > | Base
Protected Member Functions inherited from Gaudi::Generic3D< INTERFACE, IMPLEMENTATION >
| Generic3D (IMPLEMENTATION *p)
| constructor More...

## Detailed Description

AIDA implementation for 3 D histograms using ROOT THD2.

Author
  M.Frank

Definition at line 17 of file H3D.h.

## Constructor & Destructor Documentation

## ◆ Histogram3D() [1/2]

Gaudi::Histogram3D::Histogram3D | ( |  | ) |

Standard Constructor.

Definition at line 60 of file H3D.cpp.

60 : Base( new TH3D() ) {
61 setTitle( "" );
62 m_rep->Sumw2();
63 m_sumwx = 0;
64 m_sumwy = 0;
65 m_sumwz = 0;
66 m_rep->SetDirectory( nullptr );
67 }
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Generic3D::Base
Generic3D< INTERFACE, IMPLEMENTATION > Base
Definition: Generic3D.h:37
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
Gaudi::Generic3D::setTitle
bool setTitle(const std::string &title) override
Set the title of the object.
Definition: Generic3D.h:227
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45

## ◆ Histogram3D() [2/2]

Gaudi::Histogram3D::Histogram3D | ( | TH3D * | rep | ) |

Standard Constructor.

Definition at line 69 of file H3D.cpp.

69 {
70 adoptRepresentation( rep );
71 m_sumwx = 0;
72 m_sumwy = 0;
73 m_sumwz = 0;
74 m_rep->SetDirectory( nullptr );
75 }
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
Gaudi::Generic3D::adoptRepresentation
void adoptRepresentation(TObject *rep) override
Adopt ROOT histogram representation.
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45

## Member Function Documentation

## ◆ cast()

void * Gaudi::Histogram3D::cast | ( | const std::string & | className | ) | const
| override

Introspection method.

Definition at line 108 of file H3D.cpp.

108 {
109 if ( className == "AIDA::IHistogram3D" ) {
110 return (AIDA::IHistogram3D*)this;
111 } else if ( className == "AIDA::IHistogram" ) {
112 return (AIDA::IHistogram*)this;
113 }
114 return nullptr;
115 }

## ◆ classID()

static const CLID& Gaudi::Histogram3D::classID | ( |  | ) |
| inline static

Definition at line 39 of file H3D.h.

39 { return CLID_H3D; }

## ◆ clID()

const CLID& Gaudi::Histogram3D::clID | ( |  | ) | const
| inline override virtual

Retrieve reference to class defininition identifier.

Reimplemented from DataObject.

Definition at line 38 of file H3D.h.

38 { return classID(); }
Gaudi::Histogram3D::classID
static const CLID & classID()
Definition: H3D.h:39

## ◆ copyFromAida()

void Gaudi::Histogram3D::copyFromAida | ( | const AIDA::IHistogram3D & | h | ) |

Create new histogram from any AIDA based histogram.

Definition at line 149 of file H3D.cpp.

149 {
150 // implement here the copy
151 const char* title = h.title().c_str();
152 if ( h.xAxis().isFixedBinning() && h.yAxis().isFixedBinning() && h.zAxis().isFixedBinning() ) {
153 m_rep.reset( new TH3D( title, title, h.xAxis().bins(), h.xAxis().lowerEdge(), h.xAxis().upperEdge(),
154 h.yAxis().bins(), h.yAxis().lowerEdge(), h.yAxis().upperEdge(), h.zAxis().bins(),
155 h.zAxis().lowerEdge(), h.zAxis().upperEdge() ) );
156 } else {
157 Edges eX, eY, eZ;
158 for ( int i = 0; i < h.xAxis().bins(); ++i ) eX.push_back( h.xAxis().binLowerEdge( i ) );
159 // add also upperedges at the end
160 eX.push_back( h.xAxis().upperEdge() );
161 for ( int i = 0; i < h.yAxis().bins(); ++i ) eY.push_back( h.yAxis().binLowerEdge( i ) );
162 // add also upperedges at the end
163 eY.push_back( h.yAxis().upperEdge() );
164 for ( int i = 0; i < h.zAxis().bins(); ++i ) eZ.push_back( h.zAxis().binLowerEdge( i ) );
165 // add also upperedges at the end
166 eZ.push_back( h.zAxis().upperEdge() );
167 m_rep.reset(
168 new TH3D( title, title, eX.size() - 1, &eX.front(), eY.size() - 1, &eY.front(), eZ.size() - 1, &eZ.front() ) );
169 }
170 m_xAxis.initialize( m_rep->GetXaxis(), true );
171 m_yAxis.initialize( m_rep->GetYaxis(), true );
172 m_zAxis.initialize( m_rep->GetZaxis(), true );
173 const TArrayD* a = m_rep->GetSumw2();
174 if ( !a || ( a && a->GetSize() == 0 ) ) m_rep->Sumw2();
175 m_sumEntries = 0;
176 m_sumwx = 0;
177 m_sumwy = 0;
178 m_sumwz = 0;
179
180 // statistics
181 double sumw = h.sumBinHeights();
182 double sumw2 = 0;
183 if ( h.equivalentBinEntries() != 0 ) sumw2 = ( sumw * sumw ) / h.equivalentBinEntries();
184 double sumwx = h.meanX() * h.sumBinHeights();
185 double sumwx2 = ( h.meanX() * h.meanX() + h.rmsX() * h.rmsX() ) * h.sumBinHeights();
186 double sumwy = h.meanY() * h.sumBinHeights();
187 double sumwy2 = ( h.meanY() * h.meanY() + h.rmsY() * h.rmsY() ) * h.sumBinHeights();
188 double sumwz = h.meanZ() * h.sumBinHeights();
189 double sumwz2 = ( h.meanZ() * h.meanZ() + h.rmsZ() * h.rmsZ() ) * h.sumBinHeights();
190 double sumwxy = 0;
191 double sumwxz = 0;
192 double sumwyz = 0;
193
194 // copy the contents in (AIDA underflow/overflow are -2,-1)
195 for ( int i = -2; i < xAxis().bins(); ++i ) {
196 for ( int j = -2; j < yAxis().bins(); ++j ) {
197 for ( int k = -2; k < zAxis().bins(); ++k ) {
198 m_rep->SetBinContent( rIndexX( i ), rIndexY( j ), rIndexZ( k ), h.binHeight( i, j, k ) );
199 m_rep->SetBinError( rIndexX( i ), rIndexY( j ), rIndexZ( k ), h.binError( i, j, k ) );
200 // calculate statistics
201 if ( i >= 0 && j >= 0 && k >= 0 ) {
202 sumwxy += h.binHeight( i, j, k ) * h.binMeanX( i, j, k ) * h.binMeanY( i, j, k );
203 sumwxz += h.binHeight( i, j, k ) * h.binMeanX( i, j, k ) * h.binMeanZ( i, j, k );
204 sumwyz += h.binHeight( i, j, k ) * h.binMeanY( i, j, k ) * h.binMeanZ( i, j, k );
205 }
206 }
207 }
208 }
209 // need to do set entries after setting contents otherwise root will recalulate them
210 // taking into account how many time SetBinContents() has been called
211 m_rep->SetEntries( h.allEntries() );
212
213 // fill stat vector
214 std::vector<double> stat( 11 );
215 stat[0] = sumw;
216 stat[1] = sumw2;
217 stat[2] = sumwx;
218 stat[3] = sumwx2;
219 stat[4] = sumwy;
220 stat[5] = sumwy2;
221 stat[6] = sumwxy;
222 stat[7] = sumwz;
223 stat[8] = sumwz2;
224 stat[9] = sumwxz;
225 stat[10] = sumwyz;
226 m_rep->PutStats( &stat.front() );
227 }
Gaudi::Generic3D::rIndexX
int rIndexX(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::m_xAxis
Gaudi::Axis m_xAxis
Definition: Generic3D.h:213
Gaudi::Generic3D::rIndexZ
int rIndexZ(int index) const
Definition: Generic3D.h:83
Gaudi::Generic3D::m_yAxis
Gaudi::Axis m_yAxis
Definition: Generic3D.h:214
Gaudi::Generic3D::xAxis
const AIDA::IAxis & xAxis() const override
Get the x axis of the IHistogram3D.
Definition: Generic3D.h:170
Gaudi::Generic3D::title
std::string title() const override
Get the title of the object.
Definition: Generic3D.h:54
Gaudi::Edges
std::vector< double > Edges
Definition: GaudiPI.h:17
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:82
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
std::vector::push_back
T push_back(T... args)
Gaudi::Generic3D::zAxis
const AIDA::IAxis & zAxis() const override
Get the z axis of the IHistogram3D.
Definition: Generic3D.h:174
std::unique_ptr::reset
T reset(T... args)
Gaudi::Generic3D::m_zAxis
Gaudi::Axis m_zAxis
Definition: Generic3D.h:215
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
std::string::size
T size(T... args)
std::vector< double >
Gaudi::Generic3D::m_sumEntries
int m_sumEntries
Definition: Generic3D.h:223
Gaudi::Axis::initialize
void initialize(TAxis *itaxi, bool)
Definition: Axis.h:63
std::string::c_str
T c_str(T... args)
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45
Gaudi::Generic3D::yAxis
const AIDA::IAxis & yAxis() const override
Get the y axis of the IHistogram3D.
Definition: Generic3D.h:172

## ◆ fill()

bool Gaudi::Histogram3D::fill | ( | double | x,
|  | double | y,
|  | double | z,
|  | double | weight
| ) |  |
| override

Fill bin content.

Definition at line 101 of file H3D.cpp.

101 {
102 // avoid race conditiosn when filling the histogram
103 std::lock_guard<std::mutex> guard( m_fillSerialization );
104 m_rep->Fill( x, y, z, weight );
105 return true;
106 }
Gaudi::Histogram3D::m_fillSerialization
std::mutex m_fillSerialization
Definition: H3D.h:48
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
std::lock_guard

## ◆ reset()

bool Gaudi::Histogram3D::reset | ( |  | ) |
| override

Definition at line 92 of file H3D.cpp.

92 {
93 m_sumwx = 0;
94 m_sumwy = 0;
95 m_sumwz = 0;
96 m_sumEntries = 0;
97 m_rep->Reset();
98 return true;
99 }
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
Gaudi::Generic3D::m_sumEntries
int m_sumEntries
Definition: Generic3D.h:223
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45

## ◆ setBinContents()

bool Gaudi::Histogram3D::setBinContents | ( | int | i,
|  | int | j,
|  | int | k,
|  | int | entries,
|  | double | height,
|  | double | error,
|  | double | centreX,
|  | double | centreY,
|  | double | centreZ
| ) |  |
| virtual

Fast filling method for a given bin. It can be also the over/underflow bin.

Definition at line 78 of file H3D.cpp.

79 {
80 m_rep->SetBinContent( rIndexX( i ), rIndexY( j ), rIndexZ( k ), height );
81 m_rep->SetBinError( rIndexX( i ), rIndexY( j ), rIndexZ( k ), error );
82 // accumulate sum bin centers
83 if ( i >= 0 && j >= 0 && k >= 0 ) {
84 m_sumwx += centreX * height;
85 m_sumwy += centreY * height;
86 m_sumwz += centreZ * height;
87 }
88 m_sumEntries += entries;
89 return true;
90 }
Gaudi::Generic3D::rIndexX
int rIndexX(int index) const
Definition: Generic3D.h:81
Gaudi::Generic3D::rIndexZ
int rIndexZ(int index) const
Definition: Generic3D.h:83
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Generic3D::rIndexY
int rIndexY(int index) const
Definition: Generic3D.h:82
Gaudi::Generic3D::entries
int entries() const override
Get the number or all the entries.
Definition: Generic3D.h:241
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
Gaudi::Generic3D::m_sumEntries
int m_sumEntries
Definition: Generic3D.h:223
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45

## ◆ setRms()

bool Gaudi::Histogram3D::setRms | ( | double | rmsX,
|  | double | rmsY,
|  | double | rmsZ
| ) |  |
| virtual

Sets the rms of the histogram.

Definition at line 123 of file H3D.cpp.

123 {
124 m_rep->SetEntries( m_sumEntries );
125 std::vector<double> stat( 11 );
126 // sum weights
127 stat[0] = sumBinHeights();
128 stat[1] = 0;
129 if ( equivalentBinEntries() != 0 ) stat[1] = ( sumBinHeights() * sumBinHeights() ) / equivalentBinEntries();
130 stat[2] = m_sumwx;
131 double meanX = 0;
132 if ( sumBinHeights() != 0 ) meanX = m_sumwx / sumBinHeights();
133 stat[3] = ( meanX * meanX + rmsX * rmsX ) * sumBinHeights();
134 stat[4] = m_sumwy;
135 double meanY = 0;
136 if ( sumBinHeights() != 0 ) meanY = m_sumwy / sumBinHeights();
137 stat[5] = ( meanY * meanY + rmsY * rmsY ) * sumBinHeights();
138 stat[6] = 0;
139 stat[7] = m_sumwz;
140 double meanZ = 0;
141 if ( sumBinHeights() != 0 ) meanZ = m_sumwz / sumBinHeights();
142 stat[8] = ( meanZ * meanZ + rmsZ * rmsZ ) * sumBinHeights();
143 // do not need to use sumwxy sumwxz and sumwyz
144
145 m_rep->PutStats( &stat.front() );
146 return true;
147 }
Gaudi::Generic3D::sumBinHeights
double sumBinHeights() const override
Get the sum of in range bin heights in the IProfile.
Definition: Generic3D.h:261
Gaudi::Histogram3D::m_sumwx
double m_sumwx
Definition: H3D.h:43
Gaudi::Histogram3D::m_sumwy
double m_sumwy
Definition: H3D.h:44
Gaudi::Generic3D::meanX
double meanX() const override
The mean of the IHistogram3D along the x axis.
Definition: Generic3D.h:157
Gaudi::Generic3D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic3D.h:219
Gaudi::Generic3D::rmsY
double rmsY() const override
The RMS of the IHistogram3D along the y axis.
Definition: Generic3D.h:166
std::vector< double >
Gaudi::Generic3D::m_sumEntries
int m_sumEntries
Definition: Generic3D.h:223
Gaudi::Generic3D::rmsZ
double rmsZ() const override
The RMS of the IHistogram3D along the z axis.
Definition: Generic3D.h:168
Gaudi::Generic3D::meanY
double meanY() const override
The mean of the IHistogram3D along the y axis.
Definition: Generic3D.h:160
Gaudi::Generic3D::rmsX
double rmsX() const override
The RMS of the IHistogram3D along the x axis.
Definition: Generic3D.h:164
Gaudi::Histogram3D::m_sumwz
double m_sumwz
Definition: H3D.h:45
Gaudi::Generic3D::meanZ
double meanZ() const override
The mean of the IHistogram3D along the z axis.
Definition: Generic3D.h:162
Gaudi::Generic3D::equivalentBinEntries
double equivalentBinEntries() const override
Number of equivalent entries, i.e. SUM[ weight ] ^ 2 / SUM[ weight^2 ]
Definition: Generic3D.h:271

## Member Data Documentation

## ◆ m_fillSerialization

std::mutex Gaudi::Histogram3D::m_fillSerialization
| private

Definition at line 48 of file H3D.h.

## ◆ m_sumwx

double Gaudi::Histogram3D::m_sumwx = 0
| protected

Definition at line 43 of file H3D.h.

## ◆ m_sumwy

double Gaudi::Histogram3D::m_sumwy = 0
| protected

Definition at line 44 of file H3D.h.

## ◆ m_sumwz

double Gaudi::Histogram3D::m_sumwz = 0
| protected

Definition at line 45 of file H3D.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/GaudiCommonSvc/H3D.h
- GaudiCommonSvc/src/HistogramSvc/H3D.cpp